=== debian/changelog ===
openscad (2014.03+dfsg-1) unstable; urgency=low

  * New upstream version
    - resize module
    - scale parameter on linear_extrude
    - recursive use of modules
    - assignments can depend on previous assignments
    - syntax highlighting
    - user library path
    - support for opening dxf files
    - new behavior of preview and highlight operators
    - new diameter arguments
    - parent_module() and children() functions
    - Unicode handling
    - negative steps in ranges
    - norm() and cross() functions
    - new command line options
    - bugfixes
    - drops many test programs which caused issues when ran outside the build
      directory
  * Copyright file updates
  * Build-depend on glib
  * Build-conflict against libgles2-dev (eg libgles2-mesa-dev)
  * Patches dropped due to upstream inclusion:
    - changes to eigen.pri
  * Patch out verbose mode through qmake
  * Patch tests/CTestCustom.template to use test_pretty_print.py instead of
    the test_pretty_print.c wrapper that is just used to transport a hardcoded
    path that is not present on installed systems anyway
  * Patch tests/test_pretty_print.py to use Debian package information instead
    of unavailable git information
  * Drop scripts directory for +dfsg repackaging
  * Explicitly set OpenSCAD version from upstream version
  * Patch tests/test_cmdline_tool.py to use absolute paths (because openscad
    and echotest have different behaviors in that respect)
  * Add build dependencies to run the test suite at build time
  * Depend on openscad-mcad for building to run the test suite
    - Patch out check for MCAD subtree
  * Change Standards-Version to 3.9.5 (no further changes)

 -- Christian M. Amsüss <chrysn@fsfe.org>  Mon, 10 Mar 2014 20:08:15 +0100
