## openscad 2015.03

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -59,6 +59,7 @@
     set(CMAKE_BUILD_TYPE RelWithDebInfo)
   endif()
 endif()
+message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
 
 if(CMAKE_COMPILER_IS_GNUCXX)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-strict-aliasing")
@@ -66,11 +67,33 @@
 
 if(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DDEBUG")
+else()
+  # asserts will be compiled out with NDEBUG -- must remove it
+  foreach (flags_var_to_scrub
+           CMAKE_CXX_FLAGS_RELEASE
+           CMAKE_CXX_FLAGS_RELWITHDEBINFO
+           CMAKE_CXX_FLAGS_MINSIZEREL
+           CMAKE_C_FLAGS_RELEASE
+           CMAKE_C_FLAGS_RELWITHDEBINFO
+           CMAKE_C_FLAGS_MINSIZEREL)
+    string(REGEX REPLACE "(^| )[/-]D *NDEBUG($| )" " "
+           "${flags_var_to_scrub}" "${${flags_var_to_scrub}}")
+  endforeach()
 endif()
 
 # MCAD
 if(NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../libraries/MCAD/__init__.py)
   message(FATAL_ERROR "MCAD not found. You can install from the OpenSCAD root as follows: \n  git submodule update --init")
+endif()
+
+# NULLGL - Allow us to build without OpenGL(TM). run 'cmake .. -DNULLGL=1'
+# Most tests will fail, but it can be used for testing/experiments
+
+if(NULLGL)
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNULLGL")
+  set(SKIP_IMAGEMAGICK "1") # we dont generate png, so nothing to compare
+else()
+  set(ENABLE_OPENCSG_FLAG "-DENABLE_OPENCSG")
 endif()
 
 #
@@ -113,8 +136,10 @@
   # you have to pass -DCMAKE_VERBOSE_MAKEFILE=ON to cmake when you run it. 
 endif()
 
-if(WIN32 AND CMAKE_COMPILER_IS_GNUCXX)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive -frounding-math")
+if(CMAKE_COMPILER_IS_GNUCXX)
+  if (WIN32 OR ${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive -frounding-math")
+  endif()
 endif()
 
 # Clang compiler
@@ -124,7 +149,6 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-parameter")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-variable")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-function")
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-c++11-extensions")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-sign-compare")
 endif()
 
@@ -139,27 +163,34 @@
   # their set_paths to be a priority. 
 
   if (DEBUG_OSCD)
-    message(STATUS "inclusion ${user_set_path} ${found_paths}")
-    message(STATUS "inclusion ${${user_set_path}} ${${found_paths}}")
-  endif()
-  set( inclusion_match 0 )
-  foreach( found_path ${${found_paths}} )
-    if (${found_path} MATCHES ${${user_set_path}}.*)
-      set( inclusion_match 1 )
+    message(STATUS "inclusion:")
+    message(STATUS "  ${user_set_path}: ${${user_set_path}}")
+    message(STATUS "  ${found_paths}: ${${found_paths}}")
+  endif()
+  set(inclusion_match 0)
+  if (${user_set_path})
+    foreach(found_path ${${found_paths}})
+      string(FIND ${found_path} ${${user_set_path}} INDEX)
+      if (DEFINED INDEX)
+        if (${INDEX} EQUAL 0)
+          set(inclusion_match 1)
+        endif()
+      endif()
+    endforeach()
+    if (inclusion_match)
+      include_directories(BEFORE ${${found_paths}})
+      if (DEBUG_OSCD)
+        message(STATUS "inclusion prepend ${${found_paths}} for ${user_set_path}")
+      endif()
+      set(inclusion_match 0)
     endif()
-  endforeach()
-  if (user_set_path AND inclusion_match)
-    include_directories(BEFORE ${${found_paths}})
-    if (DEBUG_OSCD)
-      message(STATUS "inclusion prepend ${${found_paths}} for ${user_set_path}")
-    endif()
-  else()
+  endif()
+  if (NOT inclusion_match)
     include_directories(AFTER ${${found_paths}})
     if (DEBUG_OSCD)
       message(STATUS "inclusion append ${${found_paths}} for ${user_set_path}")
     endif()
   endif()
-  set( inclusion_match 0 )
 endfunction()
 
 # Boost
@@ -194,14 +225,26 @@
 endif()
 
 find_package( Boost 1.35.0 COMPONENTS thread program_options filesystem system regex REQUIRED)
-message(STATUS "Boost includes found: " ${Boost_INCLUDE_DIRS})
+message(STATUS "Boost ${Boost_VERSION} includes found: " ${Boost_INCLUDE_DIRS})
 message(STATUS "Boost libraries found:")
 foreach(boostlib ${Boost_LIBRARIES})
   message(STATUS "  " ${boostlib})
 endforeach()
 
 inclusion(BOOST_ROOT Boost_INCLUDE_DIRS)
-add_definitions(-DBOOST_FILESYSTEM_VERSION=3) # Use V3 for boost 1.44-1.45
+if (${Boost_VERSION} LESS 104600)
+  add_definitions(-DBOOST_FILESYSTEM_VERSION=3) # Use V3 for boost 1.44-1.45
+endif()
+
+# On Mac, we need to link against the correct C++ library. We choose the same one
+# as Boost uses.
+if(APPLE)
+  execute_process(COMMAND grep -q __112basic_string ${Boost_LIBRARIES}
+                  RESULT_VARIABLE BOOST_USE_STDLIBCPP)
+  if (NOT BOOST_USE_STDLIBCPP)
+     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
+  endif()
+endif()
 
 # Mac OS X
 if(APPLE)
@@ -233,11 +276,13 @@
 endif()
 
 if (NOT EIGEN_INCLUDE_DIR)
-  find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS ${OPENSCAD_LIBDIR}/include/eigen3)
+  # The NO_CMAKE_SYSTEM_PATH is necessary to avoid OS X from picking up 
+  # a stray Eigen from /Library/Framework
+  find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS ${OPENSCAD_LIBDIR}/include/eigen3 NO_CMAKE_SYSTEM_PATH)
 endif()
 
 if (NOT EIGEN_INCLUDE_DIR)
-  if (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
+  if (${CMAKE_SYSTEM_NAME} MATCHES "^FreeBSD")
     find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS /usr/local/include/eigen3)
   elseif (${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
     find_path(EIGEN_INCLUDE_DIR Eigen/Core HINTS /usr/pkg/include/eigen3)
@@ -254,6 +299,10 @@
   message(STATUS "Eigen found in " ${EIGEN_INCLUDE_DIR})
   inclusion(EIGEN_DIR EIGEN_INCLUDE_DIR)
 endif()
+
+###### NULLGL wraps all OpenGL(TM) items (GL, Glew, OpenCSG)
+###### Several pages of code fall under this 'if( NOT NULLGL )'
+if (NOT NULLGL)
 
 # OpenGL
 find_package(OpenGL REQUIRED)
@@ -327,51 +376,8 @@
 
 inclusion(GLEW_DIR GLEW_INCLUDE_DIR)
 
+endif() ########## NULLGL ENDIF
+
 # Flex/Bison
 find_package(BISON REQUIRED)
 
-if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
-  # FreeBSD has an old flex in /usr/bin and a new flex in /usr/local/bin
-  set(FLEX_EXECUTABLE /usr/local/bin/flex)
-endif()
-
-# prepend the dir where deps were built
-if (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
-  set(OSCAD_DEPS "")
-  set(OSCAD_DEPS_PATHS $ENV{OPENSCAD_LIBRARIES}/include)
-  inclusion(OSCAD_DEPS OSCAD_DEPS_PATHS)
-endif()
-
-if(${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
-  include_directories( /usr/pkg/include /usr/X11R7/include )
-  set(FLEX_EXECUTABLE /usr/pkg/bin/flex)
-  if(NOT ${CMAKE_CXX_COMPILER} MATCHES ".*clang.*")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
-  endif()
-endif()
-
-find_package(FLEX REQUIRED)
-# The COMPILE_FLAGS and forced C++ compiler is just to be compatible with qmake
-if (WIN32)
-  set(FLEX_UNISTD_FLAG "-DYY_NO_UNISTD_H")
-endif()
-FLEX_TARGET(OpenSCADlexer ../src/lexer.l ${CMAKE_CURRENT_BINARY_DIR}/lexer.cpp COMPILE_FLAGS "-Plexer ${FLEX_UNISTD_FLAG}")
-BISON_TARGET(OpenSCADparser ../src/parser.y ${CMAKE_CURRENT_BINARY_DIR}/parser_yacc.c COMPILE_FLAGS "-p parser")
-ADD_FLEX_BISON_DEPENDENCY(OpenSCADlexer OpenSCADparser)
-set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/parser_yacc.c PROPERTIES LANGUAGE "CXX")
-
-# CGAL
-
-if (NOT $ENV{CGALDIR} STREQUAL "")
-  set(CGAL_DIR "$ENV{CGALDIR}")
-elseif (NOT $ENV{OPENSCAD_LIBRARIES} STREQUAL "")
-  if (EXISTS "$ENV{OPENSCAD_LIBRARIES}/lib/CGAL")
-    set(CGAL_DIR "$ENV{OPENSCAD_LIBRARIES}/lib/CGAL")
-    set(CMAKE_MODULE_PATH "${CGAL_DIR}" ${CMAKE_MODULE_PATH})
-  elseif (EXISTS "$ENV{OPENSCAD_LIBRARIES}/include/CGAL")
-    set(CGAL_DIR "$ENV{OPENSCAD_LIBRARIES}")
-    set(CMAKE_MODULE_PATH "${CGAL_DIR}" ${CMAKE_MODULE_PATH})
-  endif()
-endif()
-message(STATUS "CGAL_DIR: " ${CGAL_DIR})
-find_package(CGAL REQUIRED)
