## openscad 2015.03-1+dfsg

=== debian/changelog ===
openscad (2015.03-1+dfsg-3) unstable; urgency=medium

  * Use libgl1-mesa-dri instead of the abandoned libgl1-mesa-swx11 (Closes:
    #803248)
  * Build-depend on libcgal-qt5-dev (see #804539)
  * Add lintian override against source-is-missing (see #798900)
  * Change repository URIs to collab-maint
  * Add a note about the build logs to README.source

 -- Christian M. Amsüss <chrysn@fsfe.org>  Mon, 09 Nov 2015 14:00:17 +0100

openscad (2015.03-1+dfsg-2) unstable; urgency=medium

  * Output the tests' HTML rendering to the build log on failure
  * Go back to being lax about regression tests (See #795300)

 -- Christian M. Amsüss <chrysn@fsfe.org>  Fri, 14 Aug 2015 14:46:19 +0200

openscad (2015.03-1+dfsg-1) unstable; urgency=medium

  [ Chow Loong Jin ]

  * New upstream version
    + Language Features
      - Added text() module for 2D text
      - Added offset() module for 2D offsets
      - Added list comprehensions and let()
      - Added concat() function
      - Added chr() function
      - surface() can now take PNG images as input
      - min() and max() can now take a vector argument
      - 2D minkowski can now handle polygons with holes
      - Variables can now be assigned in local blocks without using assign()
    + Program Features
      - Added Toolbar icons
      - New code editor based on QScintilla
      - Added Splash screen
      - Added SVG export
      - Added AMF export
      - Added --viewall and --autocenter cmd-line parameters
      - GUI is now translated into German, Czech, Spanish, French and Russian
      - MDI (Multiple Document Interface) is now available on all platforms
      - Color schemes for viewer and editor can be user-edited using JSON files
      - GUI components are now dockable
      - Added Tickmarks on axes
    + Bugfixes/improvements
      - Performance improvement: 2D (clipper), preview, hull, minkowski, surface
      - Performance improvement: Reduce duplicate evaluation of identical
        expressions
      - Better recursion behavior
      - STL export and import is now more robust
      - Internal cavities are better supported
      - New examples
      - Windows cmd-line behaves better
      - Better mirror() and scale() behavior when using negative factors
      - Fixes a segfault bug (Closes: #787127)
      - Removes __DATE__ reference (Closes: #781638)
    + Deprecations
      - polyhedron() now takes a faces= argument rather than triangles=
      - assign() is no longer needed. Local variables can be created in any
        scope
  * Use qt5
  * Bump Standards-Version to 3.9.6
  * Fix up watch file options
  * Update what goes in the +dfsg package
    - Remove src/SparkleAutoUpdater.* from dfsg branch
  * Update +dfsg branch mechanisms to uscan
  * Update debian/copyright
  * Set uversionmangle in debian/watch for microreleases
  * New patches
    * Build system: Work around missing -lX11
    * Add hashbang to test_cmdline_tool.py

  [ Christian M. Amsüss ]

  * Switch source to using gbp pq
  * Depend on versioned imagemagick to avoid issues with graphicsmagick
  * Updated patches
  * New patches
    * Run tests with the shipped OpenSCAD binary
    * Minor spelling and syntax fixes
  * Don't build programs used neither in shipping nor for tests
  * Use debhelper's cmake / ctest targets
  * Drop chrpath tricks
  * Drop installation of build test results
  * Add README for test suite
  * Unconditionally render build time tests in virtual frame buffer
  * Exclude the tests known to fail from building, require the rest to work
  * Install EMACS mode (Closes: #789318)
  * Add DEP-3 tags to patches
  * Fix building with DEB_BUILD_OPTIONS=nocheck
  * Ship the provided font files in the test data
    - Override lintian's warnings against it

 -- Christian M. Amsüss <chrysn@fsfe.org>  Tue, 11 Aug 2015 18:15:32 +0200
