=== debian/control ===
--- 
+++ 
@@ -1,21 +1,22 @@
 Source: openscad
 Priority: optional
 Maintainer: Christian M. Amsüss <chrysn@fsfe.org>
-# while it is common to have libgl1-mesa-dev as the default option for
-# libgl1-dev, libgl1-mesa-swx11-dev is chosen here to avoid that an installer
-# for a build server gets the idea of installing xserver-xorg-core; also, this
-# is why the sequence of xserver-xorg-core and xvfb is flipped here relative to
-# openscad-testing, where they come from.
+# libcgal-qt5-dev is a workaround for http://bugs.debian.org/804539
 Build-Depends:
     debhelper (>= 9),
-    qt4-qmake (>=4.4),
+    qt5-qmake,
+    libcgal-qt5-dev,
     libcgal-dev (>=3.6),
     libopencsg-dev (>=1.3.0),
+    libqt5scintilla2-dev,
+    libfreetype6-dev,
+    libfontconfig1-dev,
+    libharfbuzz-dev,
     libeigen3-dev,
     libglib2.0-dev,
     bison (>= 2.4),
     flex (>=2.5.35),
-    libqt4-opengl-dev,
+    libqt5opengl5-dev,
     libglew-dev (>= 1.5.4) | libglew1.6-dev | libglew1.5-dev (>= 1.5.4),
     libgmp-dev | libgmp10-dev | libgmp3-dev,
     libmpfr-dev,
@@ -25,23 +26,24 @@
     libboost-regex-dev,
     libboost-system-dev,
     libboost-filesystem-dev,
-    chrpath,
     pkg-config,
-    imagemagick,
-    libgl1-mesa-swx11-dev | libgl-dev,
-    xvfb | xserver-xorg-core,
-    libgl1-mesa-swx11 | xserver-xorg-core,
-    openscad-mcad
+    imagemagick (>= 6.5.9.3),
+    libgl1-mesa-dri,
+    xvfb,
+    libgl1-mesa-dev,
+    openscad-mcad,
+    ttf-marvosym,
+    fonts-hosny-amiri
 # openscad is not gles compatible yet. this line makes builds abort before they
 # faile at compile time. libqt4-opengl-dev currently pulls libgles2-mesa-dev in
 # on ubuntu arm{el,hf}.
 Build-Conflicts:
     libgles2-dev
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Section: graphics
 Homepage: http://openscad.org/
-Vcs-Browser: http://gitorious.org/openscad-debian/openscad/commits/debian
-Vcs-Git: git://gitorious.org/openscad-debian/openscad.git/ -b debian
+Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/openscad.git/
+Vcs-git: git://anonscm.debian.org/collab-maint/openscad.git -b debian
 
 Package: openscad
 Architecture: any
@@ -67,6 +69,7 @@
 
 Package: openscad-testing
 Architecture: any
+# the versioned imagemagick dependency stems from https://github.com/openscad/openscad/issues/1360
 Depends:
     ${shlibs:Depends},
     ${misc:Depends},
@@ -75,9 +78,9 @@
     python,
     python-argparse,
     cmake,
-    imagemagick,
+    imagemagick (>= 6.5.9.3),
     xserver-xorg-core | xvfb,
-    xserver-xorg-core | libgl1-mesa-swx11
+    libgl1-mesa-dri
 Description: script file based graphical CAD environment (test suite)
  OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
  aspects rather than artistic ones.
@@ -89,7 +92,9 @@
 Depends:
     ${shlibs:Depends},
     ${misc:Depends},
-    openscad-mcad
+    openscad-mcad,
+    ttf-marvosym,
+    fonts-hosny-amiri
 # the examples, which are shipped in openscad, are part of the test suite
 Recommends: openscad
 Suggests: openscad-testing
