=== debian/watch ===
version=3

opts=dversionmangle=s/\+dfsg$//,repacksuffix=+dfsg \
    http://files.openscad.org/openscad-([0-9.-]*).src.tar.gz
