## openscad 2015.03-2%2Bdfsg

=== debian/changelog ===
openscad (2015.03-2+dfsg-2) unstable; urgency=medium

  * Upload to unstable.
  * Add patch for translation generation (Closes: #844881)
  * Bump standards version (no changes needed)
  * Use debhelper 10
  * Drop obsolete lintian overrides
  * Implement a proper clean debian/rules target

 -- Christian M. Amsüss <chrysn@fsfe.org>  Sun, 27 Nov 2016 17:37:27 +0100

openscad (2015.03-2+dfsg-1) experimental; urgency=medium

  [ upstream ]

  * New bugfix release

  [ Christian M. Amsüss ]

  * Fix Build-Conflicts against GLES
  * Pick and enable new OpenGL widget from upstream (Closes: #806670)
  * Drop patches applied upstream, refresh and simplify others
  * Drop debug-mode workaround (now handled by debhelper for qmake)
  * Update copyright file
  * Notes on forwarded patches

 -- Christian M. Amsüss <chrysn@fsfe.org>  Fri, 08 Jan 2016 11:46:03 +0100
