=== debian/rules ===
--- 
+++ 
@@ -8,10 +8,10 @@
 export QT_SELECT = qt5
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- VERSION=$(UPSTREAMVERS)
+	dh_auto_configure -- VERSION=$(UPSTREAMVERS) CONFIG-=debug CONFIG+=qopenglwidget
 
 override_dh_auto_build:
 	dh_auto_build
@@ -73,3 +73,8 @@
 
 override_dh_strip:
 	dh_strip --dbg-package openscad-dbg
+
+override_dh_auto_clean:
+	dh_auto_clean
+
+	dh_auto_clean -Dtests -Scmake
