## openscad 2015.03-2+dfsg

=== debian/changelog ===
openscad (2015.03-2+dfsg-2ubuntu1) zesty; urgency=medium

  * Revert the Build-Conflicts change; on Ubuntu qtbase5-dev Depends on
    libgles2-dev.

 -- Iain Lane <iain@orangesquash.org.uk>  Mon, 28 Nov 2016 14:01:58 +0000
