=== debian/control ===
--- 
+++ 
@@ -1,10 +1,12 @@
 Source: openscad
 Priority: optional
-Maintainer: Christian M. Amsüss <chrysn@fsfe.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Christian M. Amsüss <chrysn@fsfe.org>
 # libcgal-qt5-dev is a workaround for http://bugs.debian.org/804539
 Build-Depends:
-    debhelper (>= 9),
+    debhelper (>= 10),
     qt5-qmake,
+    qtbase5-dev (>= 5.4),
     libcgal-qt5-dev,
     libcgal-dev (>=3.6),
     libopencsg-dev (>=1.3.0),
@@ -16,6 +18,7 @@
     libglib2.0-dev,
     bison (>= 2.4),
     flex (>=2.5.35),
+# workaround for https://github.com/openscad/openscad/issues/1543
     libqt5opengl5-dev,
     libglew-dev (>= 1.5.4) | libglew1.6-dev | libglew1.5-dev (>= 1.5.4),
     libgmp-dev | libgmp10-dev | libgmp3-dev,
@@ -35,11 +38,13 @@
     ttf-marvosym,
     fonts-hosny-amiri
 # openscad is not gles compatible yet. this line makes builds abort before they
-# faile at compile time. libqt4-opengl-dev currently pulls libgles2-mesa-dev in
-# on ubuntu arm{el,hf}.
+# faile at compile time. libqt5opengl5 uses gles on arm{el,hf}, making openscad
+# currently unbuildable there. tracked upstream as
+# https://github.com/openscad/openscad/issues/292 and in debian as
+# http://bugs.debian.org/797816
 Build-Conflicts:
     libgles2-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Section: graphics
 Homepage: http://openscad.org/
 Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/openscad.git/
